Heap
Sorting
Collaboration diagram for Heap:

## Functions

template<typename _RandomAccessIterator >
bool | std::is_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
bool | std::is_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
template<typename _RandomAccessIterator >
_RandomAccessIterator | std::is_heap_until (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
_RandomAccessIterator | std::is_heap_until (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
template<typename _RandomAccessIterator >
void | std::make_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
void | std::make_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
template<typename _RandomAccessIterator >
void | std::pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
void | std::pop_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
template<typename _RandomAccessIterator >
void | std::push_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
void | std::push_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)
template<typename _RandomAccessIterator >
void | std::sort_heap (_RandomAccessIterator __first, _RandomAccessIterator __last)
template<typename _RandomAccessIterator , typename _Compare >
void | std::sort_heap (_RandomAccessIterator __first, _RandomAccessIterator __last, _Compare __comp)

## Detailed Description

## Function Documentation

template<typename _RandomAccessIterator >

bool std::is_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

inline

Determines whether a range is a heap.

Parameters

  __first | Start of range.
  __last | End of range.

Returns
  True if range is a heap, false otherwise.

Definition at line 571 of file stl_heap.h.

References std::is_heap_until().

template<typename _RandomAccessIterator , typename _Compare >

bool std::is_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

inline

Determines whether a range is a heap using comparison functor.

Parameters

  __first | Start of range.
  __last | End of range.
  __comp | Comparison functor to use.

Returns
  True if range is a heap, false otherwise.

Definition at line 584 of file stl_heap.h.

References std::is_heap_until().

template<typename _RandomAccessIterator >

_RandomAccessIterator std::is_heap_until | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

inline

Search the end of a heap.

Parameters

  __first | Start of range.
  __last | End of range.

Returns
  An iterator pointing to the first element not in the heap.

This operation returns the last iterator i in [__first, __last) for which the range [__first, i) is a heap.

Definition at line 523 of file stl_heap.h.

References std::distance().

template<typename _RandomAccessIterator , typename _Compare >

_RandomAccessIterator std::is_heap_until | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

inline

Search the end of a heap using comparison functor.

Parameters

  __first | Start of range.
  __last | End of range.
  __comp | Comparison functor to use.

Returns
  An iterator pointing to the first element not in the heap.

This operation returns the last iterator i in [__first, __last) for which the range [__first, i) is a heap. Comparisons are made using __comp.

Definition at line 549 of file stl_heap.h.

References std::distance().

Referenced by std::is_heap().

template<typename _RandomAccessIterator >

void std::make_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

Construct a heap over a range.

Parameters

  __first | Start of heap.
  __last | End of heap.

This operation makes the elements in [__first,__last) into a heap.

Definition at line 386 of file stl_heap.h.

template<typename _RandomAccessIterator , typename _Compare >

void std::make_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

Construct a heap over a range using comparison functor.

Parameters

  __first | Start of heap.
  __last | End of heap.
  __comp | Comparison functor to use.

This operation makes the elements in [__first,__last) into a heap. Comparisons are made using __comp.

Definition at line 426 of file stl_heap.h.

Referenced by std::__heap_select(), std::partial_sort_copy(), and std::priority_queue< _Tp, _Sequence, _Compare >::priority_queue().

template<typename _RandomAccessIterator >

void std::pop_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

inline

Pop an element off a heap.

Parameters

  __first | Start of heap.
  __last | End of heap.

Precondition
  [__first, __last) is a valid, non-empty range.

This operation pops the top of the heap. The elements __first and __last-1 are swapped and [__first,__last-1) is made into a heap.

Definition at line 281 of file stl_heap.h.

template<typename _RandomAccessIterator , typename _Compare >

void std::pop_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

inline

Pop an element off a heap using comparison functor.

Parameters

  __first | Start of heap.
  __last | End of heap.
  __comp | Comparison functor to use.

This operation pops the top of the heap. The elements __first and __last-1 are swapped and [__first,__last-1) is made into a heap. Comparisons are made using comp.

Definition at line 359 of file stl_heap.h.

Referenced by std::priority_queue< _Tp, _Sequence, _Compare >::pop().

template<typename _RandomAccessIterator >

void std::push_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

inline

Push an element onto a heap.

Parameters

  __first | Start of heap.
  __last | End of heap + element.

This operation pushes the element at last-1 onto the valid heap over the range [__first,__last-1). After completion, [__first,__last) is a valid heap.

Definition at line 156 of file stl_heap.h.

template<typename _RandomAccessIterator , typename _Compare >

void std::push_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

inline

Push an element onto a heap using comparison functor.

Parameters

  __first | Start of heap.
  __last | End of heap + element.
  __comp | Comparison functor.

This operation pushes the element at __last-1 onto the valid heap over the range [__first,__last-1). After completion, [__first,__last) is a valid heap. Compare operations are performed using comp.

Definition at line 206 of file stl_heap.h.

Referenced by std::priority_queue< _Tp, _Sequence, _Compare >::push().

template<typename _RandomAccessIterator >

void std::sort_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last
| ) |  |

Sort a heap.

Parameters

  __first | Start of heap.
  __last | End of heap.

This operation sorts the valid heap in the range [__first,__last).

Definition at line 465 of file stl_heap.h.

template<typename _RandomAccessIterator , typename _Compare >

void std::sort_heap | ( | _RandomAccessIterator | __first,
|  | _RandomAccessIterator | __last,
|  | _Compare | __comp
| ) |  |

Sort a heap using comparison functor.

Parameters

  __first | Start of heap.
  __last | End of heap.
  __comp | Comparison functor to use.

This operation sorts the valid heap in the range [__first,__last). Comparisons are made using __comp.

Definition at line 494 of file stl_heap.h.

Referenced by std::partial_sort(), and std::partial_sort_copy().